SystemOrganization addCategory: #'QuATests-Prototype'!

Object subclass: #Sum
	instanceVariableNames: 'sum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!Sum class methodsFor: 'as yet unclassified' stamp: 'ras 3/5/2003 22:35'!
new
	^super new initialize! !

!Sum methodsFor: 'as yet unclassified' stamp: 'ras 1/23/2003 22:17'!
put: aNum
	sum _ sum + aNum.! !

!Sum methodsFor: 'as yet unclassified' stamp: 'ras 1/23/2003 22:22'!
initialize
	sum _ 0.! !

!Sum methodsFor: 'as yet unclassified' stamp: 'ras 1/23/2003 22:17'!
sum
	^sum! !

Object subclass: #QRMITestProxy
	instanceVariableNames: 'receiverName receiverType myProtocol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!QRMITestProxy methodsFor: 'accessing' stamp: 'ras 9/16/2004 15:57'!
initializeFromProperties: configuration
	receiverName _ configuration at: 'receiver'.
	myProtocol _ QuA instanceOf: (QuA name: '/demo/QRMIProtocol').
! !

!QRMITestProxy methodsFor: 'message handling' stamp: 'ras 6/27/2004 13:08'!
doesNotUnderstand: aMessage
	"must not sent unimpleemented messages to self as this causes infinite #doesNotUnderstand: recursion." 

	| socket result receiver tempReceiverName |
	socket _ ReadWriteStream on: (String new).
	myProtocol 
		write: receiverName 
		selector: aMessage selector 
		arguments: aMessage arguments
		to: socket.
"now act as adapter, receiving invocation message"
socket reset.
	tempReceiverName _ myProtocol readReceiverFrom: socket.
	receiver _ QuA thisCapsule quaObjAt:  tempReceiverName.
Transcript show: 'invoking ',tempReceiverName printString; cr.
	result _ receiver 
		perform: (myProtocol readSelectorFrom: socket)
		withArguments: (myProtocol readArgumentsFrom: socket).
socket _ ReadWriteStream on: (String new).
	myProtocol marshalObj: result on: socket.
"now act as proxy, receiving result"
socket reset.
	result _ myProtocol unmarshalObjFrom: socket upToEnd.
	^ result
! !

Object subclass: #TH263Adapter
	instanceVariableNames: 'sink transcoder netpipe vbuffer decoder src'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!TH263Adapter methodsFor: 'as yet unclassified' stamp: 'ras 9/29/2004 16:41'!
initializeFromProperties: configuration
	| srcCapsule sinkCapsule |
	src _ configuration at: 'src'.
	sink _ configuration at: 'sink'.
	srcCapsule _ (QuA resolve: src repositoryQuAName) capsule.
	sinkCapsule _ (QuA resolve: sink repositoryQuAName) capsule.
	
	"subcomponents are capsule objects (explicitly created within a capsule), that we promote to QuA platform objects"

"comment out the following to allow us to try declaring component dependencies, then we just need to get the components from the configuration (or instantiate if they are not found in configuration).
	transcoder _ srcCapsule instantiateLocal: (QuA name: '/demo/MPEG2H263').
	netpipe _ srcCapsule instantiateLocal: (QuA name: '/demo/NetPipe').
	vbuffer _ sinkCapsule instantiateLocal: (QuA name: '/demo/VBuffer').
	decoder _ sinkCapsule instantiateLocal: (QuA name: '/demo/H263Decoder').
"
	transcoder _ configuration at: 'transcoder'.
	netpipe _ configuration at: 'netpipe'.
	vbuffer _ configuration at: 'vbuffer'.
	decoder _ configuration at: 'decoder'.
! !

!TH263Adapter methodsFor: 'as yet unclassified' stamp: 'ras 9/13/2004 17:15'!
components
	^(Dictionary new)
		at: 'MPEG2H263' put: transcoder;
		at: 'NetPipe' put: netpipe;
		at: 'VBuffer' put: vbuffer;
		at: 'H263Decoder' put: decoder;
		yourself.
! !

!TH263Adapter methodsFor: 'as yet unclassified' stamp: 'ras 9/10/2004 22:41'!
sink: anObject
	sink _ anObject! !

!TH263Adapter methodsFor: 'as yet unclassified' stamp: 'ras 9/10/2004 22:43'!
start! !

Object subclass: #Chess
	instanceVariableNames: 'board player1 player2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!Chess methodsFor: 'as yet unclassified' stamp: 'ras 9/16/2004 15:57'!
initializeFromProperties: properties
	board _ QuA resolve: (properties at: 'board').
	QuA bind: (properties at: 'board') property: 'white' to: (properties at: 'player1').
	QuA bind: (properties at: 'board') property: 'black' to: (properties at: 'player2').
	QuA bind: (properties at: 'player1') property: 'board' to: (properties at: 'board').
	QuA bind: (properties at: 'player2') property: 'board' to: (properties at: 'board').
! !

!Chess methodsFor: 'as yet unclassified' stamp: 'ras 3/18/2004 11:40'!
play
	[ board playing ] whileTrue: [ board nextPlayer play. ].
	(board nextPlayer = nil) ifTrue: [ ^'draw'. ].
	(board position: 'white king') notNil
		ifTrue: [ ^'white'. ]
		ifFalse: [ ^'black'. ].
	! !

Object subclass: #TestSink
	instanceVariableNames: 'obj'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!TestSink methodsFor: 'as yet unclassified' stamp: 'ras 4/13/2004 15:49'!
result
	^obj! !

!TestSink methodsFor: 'as yet unclassified' stamp: 'ras 6/21/2004 22:52'!
put: anObj
	obj _ anObj! !

Object subclass: #TMPEG2H263
	instanceVariableNames: 'sink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!TMPEG2H263 methodsFor: 'as yet unclassified' stamp: 'ras 9/10/2004 22:42'!
sink: anObject
	sink _ anObject! !

Object subclass: #TestSource
	instanceVariableNames: 'sink testObjFactory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!TestSource methodsFor: 'as yet unclassified' stamp: 'ras 4/13/2004 15:38'!
run: anObj
	sink put: 1.
	sink put: 'aString'.
	sink put: (testObjFactory new v1: 1; v2: 2; yourself).
	sink put: anObj
! !

!TestSource methodsFor: 'as yet unclassified' stamp: 'ras 9/16/2004 15:59'!
initializeFromProperties: configuration
	testObjFactory _ QuA instanceOf: (QuA name: '/demo/TestDataTypeFactory').! !

!TestSource methodsFor: 'as yet unclassified' stamp: 'ras 4/13/2004 15:37'!
output: anObj
	sink _ anObj! !

Object subclass: #TVDisp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

Object subclass: #TVSrc
	instanceVariableNames: 'sink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!TVSrc methodsFor: 'as yet unclassified' stamp: 'ras 9/10/2004 22:44'!
start! !

!TVSrc methodsFor: 'as yet unclassified' stamp: 'ras 9/10/2004 22:39'!
sink: anObject
	sink _ anObject! !

Object subclass: #HelloWorld
	instanceVariableNames: 'output'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!HelloWorld methodsFor: 'as yet unclassified' stamp: 'ras 3/4/2003 08:44'!
run
	output notNil ifTrue: [ output value: 'Hello World' ].
! !

!HelloWorld methodsFor: 'as yet unclassified' stamp: 'ras 3/4/2003 20:47'!
output: anObject
	output _ anObject
! !

Object subclass: #TVPlayback
	instanceVariableNames: 'vbinding src disp quality'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!TVPlayback methodsFor: 'as yet unclassified' stamp: 'ras 9/10/2004 15:59'!
vbinding
	^vbinding! !

!TVPlayback methodsFor: 'as yet unclassified' stamp: 'ras 10/6/2004 11:48'!
execute
	vbinding _ QuA 
		instantiate: (QuA name: '/demo/RemoteVAdapter') 
		properties: (Props fromQuANames: {
			'src'->src.
			'sink'->disp.
		})
		withQuality: quality.
	QuA bind: src property: 'sink' to: vbinding.
	(QuA resolve: vbinding) start.
	(QuA resolve: src) start.
! !

!TVPlayback methodsFor: 'as yet unclassified' stamp: 'ras 9/10/2004 16:14'!
src: aQuAName
	src _ aQuAName! !

!TVPlayback methodsFor: 'as yet unclassified' stamp: 'ras 9/10/2004 16:14'!
disp: aQuAName
	disp _ aQuAName! !

!TVPlayback methodsFor: 'as yet unclassified' stamp: 'ras 9/17/2004 21:04'!
quality: aQSpec
	quality _ aQSpec! !

Object subclass: #Board
	instanceVariableNames: 'turn state white black'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!Board methodsFor: 'as yet unclassified' stamp: 'ras 3/17/2004 17:42'!
position: piece
	| index |
	index _ 1.
	[ index < state size and: [(state at: index) ~= piece] ]
		whileTrue: [
			index _ index + 1.
		].
	(state at: index) = piece 
		ifTrue: [^self pointFor: index]
		ifFalse: [ ^nil ].
! !

!Board methodsFor: 'as yet unclassified' stamp: 'ras 3/17/2004 11:03'!
black: aPlayer
	black _ aPlayer! !

!Board methodsFor: 'as yet unclassified' stamp: 'ras 3/17/2004 17:30'!
move: from to: destination 
	| fromIndex piece destIndex |
	fromIndex _ self indexFor: from.
	piece _ state at: fromIndex.
	state at: fromIndex put: nil.
	destIndex _ self indexFor: destination.
	state at: destIndex put: piece.
	turn = white
		ifTrue: [ turn _ black ]
		ifFalse: [ turn _ white ].! !

!Board methodsFor: 'as yet unclassified' stamp: 'ras 3/18/2004 11:35'!
playing 
	^(self hasTwoKings) and: [ white notNil and: [ black notNil. ]. ].! !

!Board methodsFor: 'as yet unclassified' stamp: 'ras 3/17/2004 11:33'!
distanceBetweenKings
	^(self position: 'white king') squaredDistanceTo: (self position: 'black king').
! !

!Board methodsFor: 'as yet unclassified' stamp: 'ras 3/17/2004 17:22'!
nextPlayer 
	^turn.! !

!Board methodsFor: 'as yet unclassified' stamp: 'ras 3/17/2004 17:29'!
indexFor: aPoint
	^1 + aPoint x + (aPoint y * 8).
! !

!Board methodsFor: 'as yet unclassified' stamp: 'ras 9/16/2004 15:56'!
initializeFromProperties: configuration
	state _ Array new: 64.
	state at: 27 put: 'white king'.
	state at: 28 put: 'black king'.
	turn _ white.! !

!Board methodsFor: 'as yet unclassified' stamp: 'ras 3/18/2004 11:33'!
hasTwoKings 
	^(self position: 'white king') notNil and: [ (self position: 'black king') notNil. ].! !

!Board methodsFor: 'as yet unclassified' stamp: 'ras 3/17/2004 17:31'!
white: aPlayer
	white _ aPlayer.
	turn _ white.
! !

!Board methodsFor: 'as yet unclassified' stamp: 'ras 3/17/2004 17:38'!
pointFor: index
	^(index - 1 \\ 8)@(index - 1 // 8)
! !

Object subclass: #TMPEGDecoder
	instanceVariableNames: 'sink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!TMPEGDecoder methodsFor: 'as yet unclassified' stamp: 'ras 9/10/2004 22:40'!
sink: anObject
	sink _ anObject! !

!TMPEGDecoder methodsFor: 'as yet unclassified' stamp: 'ras 9/10/2004 22:44'!
start! !

Object subclass: #TH263Decoder
	instanceVariableNames: 'sink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!TH263Decoder methodsFor: 'as yet unclassified' stamp: 'ras 9/10/2004 22:41'!
sink: anObject
	sink _ anObject! !

!TH263Decoder methodsFor: 'as yet unclassified' stamp: 'ras 9/10/2004 22:44'!
start! !

Object subclass: #TestDataType
	instanceVariableNames: 'v1 v2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!TestDataType methodsFor: 'as yet unclassified' stamp: 'ras 4/13/2004 14:50'!
v1: obj
	v1 _ obj! !

!TestDataType methodsFor: 'as yet unclassified' stamp: 'ras 4/13/2004 14:51'!
cat
	^v1 printString, v2 printString! !

!TestDataType methodsFor: 'as yet unclassified' stamp: 'ras 4/13/2004 14:50'!
v2: obj
	v2 _ obj! !

Object subclass: #Gen
	instanceVariableNames: 'output'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!Gen commentStamp: 'ras 1/23/2003 22:30' prior: 0!
This class, together with Sum is used for a simple demo of creating two objects, binding them, and letting them interact.  We use this in a QuAStep1 test suite.  The following code just shows the result on the Transcript.
'	g _ Gen new.
	s _ Sum new.
	s initialize.
	g output: s.
	Transcript show: s sum; cr; endEntry.
	g doSomething.
	Transcript show: s sum; cr; endEntry.
'!

!Gen methodsFor: 'as yet unclassified' stamp: 'ras 1/23/2003 22:19'!
output: anObject
	output _ anObject! !

!Gen methodsFor: 'as yet unclassified' stamp: 'ras 5/19/2003 14:11'!
gen1To: n
	"generate some numbers and send them to output"

	(1 to: n) do: [ :num | output put: num. ].! !

Object subclass: #QuASetup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!QuASetup commentStamp: 'ras 9/7/2004 14:05' prior: 0!
This class provides code shared by many tests to setup persistent repository and broker state that is to be shared by multiple capsules.!

!QuASetup class methodsFor: 'as yet unclassified' stamp: 'ras 8/25/2004 17:01'!
initializeTemp
	"create a temporay capsule to setup (bootstrap) state that will be made persistent and used to initialize other capsules."
	QuA initialize: (QuA name: '/temp').
! !

!QuASetup class methodsFor: 'as yet unclassified' stamp: 'ras 9/29/2004 15:34'!
cacheBlueprints: arrayOfTypeClassAssociations
	"run this method to publish blueprints to global repository cache file so that all capsules with shared file system get same initial state"
	| demoRepository eachName cache capsule |
	capsule _ QuA thisCapsule.
	capsule servePersistentRepository: (QuA name: '/demo').
	demoRepository _ capsule getLocalRepository: (QuA name: '/demo').
	cache _ Dictionary new.

	arrayOfTypeClassAssociations do: [ :each |
		[:type :class | 
			eachName _ (QuA name: '/demo/' , type, 'Factory-blueprint').
			capsule
				publishFrom: (Smalltalk at: class asSymbol)
				name: eachName
				forFactoryType: (QuA name: '/demo/' , type, 'Factory')
				instanceType: (QuA name: '/demo/' , type)
				requires: Props none.
			cache at: eachName put: (demoRepository quaObjAt: eachName) copy.
		] value: each key value: each value.
	].

	(FileStream forceNewFileNamed: self cacheFileName) fileOutClass: nil andObject: cache.
! !

!QuASetup class methodsFor: 'as yet unclassified' stamp: 'ras 8/25/2004 17:23'!
cacheFileName
	^'initGlobalCache'! !

!QuASetup class methodsFor: 'as yet unclassified' stamp: 'ras 8/25/2004 17:24'!
brokerFileName
	^'implBroker'! !

!QuASetup class methodsFor: 'as yet unclassified' stamp: 'ras 10/7/2004 13:35'!
advertiseCapabilityPlans: argLists

	| broker beforeContent |
	broker _ QuA thisServiceContext implementationBroker.
	beforeContent _ broker allPlans.

	argLists do: [ :eachArgList |
		QuA advertiseCapabilityPlan: eachArgList first
		factory: (QuA name: '/demo/QRMIProxyFactory') 
		configuration: eachArgList second.
	].

	(FileStream forceNewFileNamed: self brokerFileName) fileOutClass: nil andObject: (broker copyWithout: beforeContent).
! !

!QuASetup class methodsFor: 'as yet unclassified' stamp: 'ras 9/7/2004 14:03'!
initializeWithRepository: repositoryName
	"Need to invoke #initializeTemp, #cacheBlueprints:, and #advertiseCapabilityPlans: before this setup can work."
	QuA initialize: repositoryName.
	QuA thisCapsule
		cacheStateFromFile: (self cacheFileName);
		implBrokerStateFromFile: (self brokerFileName).


! !

Object subclass: #TNetPipe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

Object subclass: #TVBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

Object subclass: #Robot
	instanceVariableNames: 'board'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!Robot methodsFor: 'as yet unclassified' stamp: 'ras 3/17/2004 11:25'!
selectBest: collectionOfMovesAndResults
	| sorted |
	sorted _ collectionOfMovesAndResults sort: [ :a :b | 
		a value hasTwoKings 
			ifFalse: [ true. ]
			ifTrue: [ b value hasTwoKings
				ifFalse: [ false. ]
				ifTrue: [ a distanceBetweenKings <= b distanceBetweenKings. ].
			].
	].
	^sorted first key.! !

!Robot methodsFor: 'as yet unclassified' stamp: 'ras 3/18/2004 11:40'!
play
	| destination from |
	"destination _ self selectBest: board possibleMoves."
	from _ board position: 'white king'.
	destination _ from + (1@0).
	board move: from to: destination.
! !

!Robot methodsFor: 'as yet unclassified' stamp: 'ras 3/17/2004 11:08'!
board: aChessBoard
	board _ aChessBoard! !

!Robot methodsFor: 'as yet unclassified' stamp: 'ras 9/16/2004 15:58'!
initializeFromProperties: configuration
! !

Object subclass: #TestComponentFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!TestComponentFactory methodsFor: 'as yet unclassified' stamp: 'ras 1/28/2004 12:18'!
hello
	^'Hello World'.
! !

Object subclass: #TMPEGAdapter
	instanceVariableNames: 'sink netpipe vbuffer decoder src'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!TMPEGAdapter methodsFor: 'as yet unclassified' stamp: 'ras 9/29/2004 16:39'!
initializeFromProperties: configuration
	| srcCapsule sinkCapsule |
	src _ configuration at: 'src'.
	sink _ configuration at: 'sink'.
	srcCapsule _ (QuA resolve: src repositoryQuAName) capsule.
	sinkCapsule _ (QuA resolve: sink repositoryQuAName) capsule.
	
	"subcomponents are capsule objects (explicitly created within a capsule), that we promote to QuA platform objects"
	
"comment out the following to allow us to try declaring component dependencies, then we just need to get the components from the configuration (or instantiate if they are not found in configuration).
	netpipe _ srcCapsule instantiateLocal: (QuA name: '/demo/NetPipe').
	vbuffer _ sinkCapsule instantiateLocal: (QuA name: '/demo/VBuffer').
	decoder _ sinkCapsule instantiateLocal: (QuA name: '/demo/MPEGDecoder').
"
	netpipe _ configuration at: 'netpipe'.
	vbuffer _ configuration at: 'vbuffer'.
	decoder _ configuration at: 'decoder'.
! !

!TMPEGAdapter methodsFor: 'as yet unclassified' stamp: 'ras 9/10/2004 22:41'!
sink: anObject
	sink _ anObject! !

!TMPEGAdapter methodsFor: 'as yet unclassified' stamp: 'ras 9/10/2004 22:43'!
start! !

!TMPEGAdapter methodsFor: 'as yet unclassified' stamp: 'ras 9/13/2004 17:15'!
components
	^(Dictionary new)
		at: 'NetPipe' put: netpipe;
		at: 'VBuffer' put: vbuffer;
		at: 'MPEGDecoder' put: decoder;
		yourself.
! !

TestCase subclass: #QuAVideoBinding
	instanceVariableNames: 'errModel qSpec mpegError h263Error'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!QuAVideoBinding commentStamp: 'ras 9/29/2004 17:30' prior: 0!
Validate example from RM2004 paper:  Select video binding based on utility of error prediction for MPEG, versus H263 video over a wireless link.  However, this test simulates the wireless network and video components so that all that is actually tested is the mechanics of representing error predictions and calculating utility for plans.
!

!QuAVideoBinding methodsFor: 'as yet unclassified' stamp: 'ras 8/25/2004 17:29'!
tearDown
	QuA thisCapsule shutdown! !

!QuAVideoBinding methodsFor: 'as yet unclassified' stamp: 'ras 10/7/2004 10:54'!
testVBinding
	| player binding components |
"to test directly (without SUnit)""
	(VideoBindingDemo new)
		setUp;
		testVBinding;
		tearDown.
"
	player _ QuA instanceOf: (QuA name: '/demo/VPlayback').
	player 
		src: (QuA instantiate: (QuA name: '/demo/VSrc'));
		disp: (QuA instantiate: (QuA name: '/demo/VDisp'));
		execute.
	binding _ player vbinding.
	self assert: ((QuA blueprintFor: binding) = (QuA name: '/demo/TMPEGAdapterFactory-blueprint')).
	components _ (QuA resolve: binding) components.
	self assert: (components size = 3).
	self assert: ((QuA blueprintFor: (components at: 'NetPipe')) = (QuA name: '/demo/TNetPipeFactory-blueprint')).
	self assert: ((QuA blueprintFor: (components at: 'VBuffer')) = (QuA name: '/demo/TVBufferFactory-blueprint')).
	self assert: ((QuA blueprintFor: (components at: 'MPEGDecoder')) = (QuA name: '/demo/TMPEGDecoderFactory-blueprint')).
! !

!QuAVideoBinding methodsFor: 'as yet unclassified' stamp: 'ras 9/29/2004 17:56'!
blueprintFor: typeStr from: classStr requires: dependencies errorPrediction: anErrorEstimator
	| eachName |
	eachName _ (QuA name: '/demo/' , classStr, 'Factory-blueprint').
	QuA thisCapsule
		publishFrom: (Smalltalk at: classStr asSymbol)
		name: eachName
		forFactoryType: (QuA name: '/demo/' , typeStr, 'Factory')
		instanceType: (QuA name: '/demo/' , typeStr)
		requires: dependencies
		errorEstimator: anErrorEstimator.

! !

!QuAVideoBinding methodsFor: 'as yet unclassified' stamp: 'ras 9/29/2004 15:39'!
blueprintFor: typeStr from: classStr
	self blueprintFor: typeStr from: classStr requires: Props none.! !

!QuAVideoBinding methodsFor: 'as yet unclassified' stamp: 'ras 9/11/2004 14:56'!
blueprintFor: typeStr from: classStr requires: dependencies
	| eachName |
	eachName _ (QuA name: '/demo/' , classStr, 'Factory-blueprint').
	QuA thisCapsule
		publishFrom: (Smalltalk at: classStr asSymbol)
		name: eachName
		forFactoryType: (QuA name: '/demo/' , typeStr, 'Factory')
		instanceType: (QuA name: '/demo/' , typeStr)
		requires: dependencies.

! !

!QuAVideoBinding methodsFor: 'as yet unclassified' stamp: 'ras 10/7/2004 11:33'!
testVBindingWithQuality
	| player binding components |
"to test directly (without SUnit)""
	(QuAVideoBinding new)
		setUp;
		testVBindingWithQuality;
		tearDown.
"
	QuA thisServiceContext 
		implementationPlanner: QoSServicePlanner new.

			
	player _ QuA instanceOf: (QuA name: '/demo/VPlayback').
	player 
		src: (QuA instantiate: (QuA name: '/demo/VSrc'));
		disp: (QuA instantiate: (QuA name: '/demo/VDisp'));
		quality: qSpec;
		execute.
	binding _ player vbinding.
	self assert: ((QuA blueprintFor: binding) = (QuA name: '/demo/TH263AdapterFactory-blueprint')).
	components _ (QuA resolve: binding) components.
	self assert: (components size = 4).
	self assert: ((QuA blueprintFor: (QuA nameFor: (components at: 'MPEG2H263'))) = (QuA name: '/demo/TMPEG2H263Factory-blueprint')).
	self assert: ((QuA blueprintFor: (QuA nameFor: (components at: 'NetPipe'))) = (QuA name: '/demo/TNetPipeFactory-blueprint')).
	self assert: ((QuA blueprintFor: (QuA nameFor: (components at: 'VBuffer'))) = (QuA name: '/demo/TVBufferFactory-blueprint')).
	self assert: ((QuA blueprintFor: (QuA nameFor: (components at: 'H263Decoder'))) = (QuA name: '/demo/TH263DecoderFactory-blueprint')).
! !

!QuAVideoBinding methodsFor: 'as yet unclassified' stamp: 'ras 10/7/2004 13:39'!
setUp
	QuA initialize: (QuA name: '/c1').
	QuA thisCapsule serveVolatileRepository: (QuA name: '/c2').
	QuA thisCapsule servePersistentRepository: (QuA name: '/demo').
	errModel _ (QuA errorModel)
		dimensions: { 'delay'. 'period'. 'noise'. };
		yourself.
	mpegError _ (TMPEGEstimator new)
		errorModel: errModel;
		yourself.
	h263Error _ (TH263Estimator new)
		errorModel: errModel;
		yourself.

	self
		blueprintFor: 'VPlayback' from: 'TVPlayback';
		blueprintFor: 'VSrc' from: 'TVSrc';
		blueprintFor: 'VDisp' from: 'TVDisp';
		blueprintFor: 'RemoteVAdapter' from: 'TMPEGAdapter'
			requires: (Props fromTypes: {
				'src'->(QuA name: '/demo/VSrc').
				'sink'->(QuA name: '/demo/VDisp').
				'netpipe'->(QuA name: '/demo/NetPipe').
				'vbuffer'->(QuA name: '/demo/VBuffer').
				'decoder'->(QuA name: '/demo/MPEGDecoder').
				})
			errorPrediction: mpegError;
		blueprintFor: 'RemoteVAdapter' from: 'TH263Adapter'
			requires: (Props fromTypes: {
				'src'->(QuA name: '/demo/VSrc').
				'sink'->(QuA name: '/demo/VDisp').
				'transcoder'->(QuA name: '/demo/MPEG2H263').
				'netpipe'->(QuA name: '/demo/NetPipe').
				'vbuffer'->(QuA name: '/demo/VBuffer').
				'decoder'->(QuA name: '/demo/H263Decoder').
				})
			errorPrediction: h263Error;
		blueprintFor: 'NetPipe' from: 'TNetPipe';
		blueprintFor: 'VBuffer' from: 'TVBuffer';
		blueprintFor: 'MPEGDecoder' from: 'TMPEGDecoder';
		blueprintFor: 'MPEG2H263' from: 'TMPEG2H263';
		blueprintFor: 'H263Decoder' from: 'TH263Decoder'.
	QuASetup advertiseCapabilityPlans: {
		{ QuA name: '/c1'. Props fromValues: { 'host'->'localhost'. 'port'->8301. }. }.
		{ QuA name: '/c2'. Props fromValues: { 'host'->'localhost'. 'port'->8000. }. }.
	}.
	
	errModel _ (QuA errorModel)
		dimensions: { 'delay'. 'period'. 'noise'. };
		yourself.
	qSpec _ (QuA qualitySpec)
			errorModel: errModel;
			inputGuarantee: ((QuA inputSpec)
				interface: (QuA name: '/demo/VBinding');
				properties: ((Dictionary new)
					at: 'period' put: ("Duration milliSeconds: " 33); 
					at: 'size' put: 40000;
					at: 'resolution' put: 300000; 
					yourself); 
				yourself);
			utility: ((QuA utilityFunction) 
				weights: ((Dictionary new)
					at: 'delay' put: ("Duration milliSeconds:" 1000);
					at: 'period' put: ("Duration milliSeconds:" 200);
					at: 'noise' put: (0.2);
					yourself);
				errorModel: errModel;
				yourself);
			yourself.



! !

TestCase subclass: #QuAQRMITest
	instanceVariableNames: 'source sink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!QuAQRMITest methodsFor: 'as yet unclassified' stamp: 'ras 8/25/2004 17:28'!
setUp
	"Need to invoke #persistentSetup, then start another Squeak runtime image and invoke #startCapsule2 before this test can work."
	| remoteAdapter |
	QuASetup initializeWithRepository: (QuA name: '/c1').
	remoteAdapter _ QuA instanceOf: (QuA name: '/demo/QRMIAdapter').
	remoteAdapter enableListenerOnPort: (8301).


! !

!QuAQRMITest methodsFor: 'as yet unclassified' stamp: 'ras 8/25/2004 17:18'!
testQRMI
	"(QuAQRMITest new)
		setUp;
		testQRMI;
		shutdown.
	"
	QuA thisServiceContext 
		compositionPlanner: (QRMITestPlanner new 
			remoteRepository: (QuA resolve: (QuA name: '/c2'));
			yourself
		).
	QuA compose: ((QuA newCompositionSpec)
			addInstanceOf: (QuA name: '/demo/TestSource') role: 'source';
			addInstanceOf: (QuA name: '/demo/TestSink') role: 'sink';
			addObject: (QuA thisCapsule quaNameFor: self) role: 'self';
			set: 'source' property: 'output' to: 'sink';
			set: 'self' property: 'source' to: 'source';
			set: 'self' property: 'sink' to: 'sink'
	) withQuality: nil.

	source run: 'test data'.

	self assert: sink result = 'test data'.
! !

!QuAQRMITest methodsFor: 'as yet unclassified' stamp: 'ras 4/13/2004 14:43'!
source: obj
	source _ obj! !

!QuAQRMITest methodsFor: 'as yet unclassified' stamp: 'ras 10/7/2004 13:38'!
persistentSetup
	"QuAQRMITest new persistentSetup"
	QuASetup initializeTemp.
	QuASetup cacheBlueprints: {
		'QRMIAdapter'->'QRMIAdapter'.
		'QRMIProxy'->'QRMIProxy'.
		'QRMIProtocol'->'QRMIProtocol'.
		'TestDataType'->'TestDataType'.
		'TestSource'->'TestSource'.
		'TestSink'->'TestSink'.
	}.
	QuASetup advertiseCapabilityPlans: {
		{ QuA name: '/c1'. Props fromValues: { 'host'->'localhost'. 'port'->8301. }. }.
		{ QuA name: '/c2'. Props fromValues: { 'host'->'localhost'. 'port'->8000. }. }.
	}
! !

!QuAQRMITest methodsFor: 'as yet unclassified' stamp: 'ras 4/13/2004 15:49'!
sink: obj
	sink _ obj! !

!QuAQRMITest methodsFor: 'as yet unclassified' stamp: 'ras 8/25/2004 17:28'!
tearDown
	QuA thisCapsule shutdown! !

!QuAQRMITest methodsFor: 'as yet unclassified' stamp: 'ras 8/25/2004 17:28'!
startCapsule2
	"QuAQRMITest new startCapsule2"

	| remoteAdapter |
	QuASetup initializeWithRepository: (QuA name: '/c2').
	remoteAdapter _ QuA instanceOf: (QuA name: '/demo/QRMIAdapter').
	remoteAdapter enableListenerOnPort: (8000).
self halt.
	QuA thisCapsule shutdown.
! !

TestCase subclass: #QuAStep1
	instanceVariableNames: 'capsule result obj obj2 reflection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!QuAStep1 commentStamp: 'ras 3/11/2003 18:29' prior: 0!
Step1: 
	configure local file system with cache of qua/platform/squeak repository components:
	- Squeak 3.4 image, VM executable, and sources files. 
		(these are not QuA components - they do not encode QuA objects)
		they are not Squeak components - they do not encode Squeak objects
		the VM is an OS-application-component - it encodes an OS process object
		the image and sources files are parts of a Squeak-VM-image-component
	- QuA platform for squeak
		this is not a QuA component - it does not encode a QuA object
	- basic service planner
	- implementation registry
	- local persistent repository
	publish in local repository components:
	- HelloWorld type (in Smalltalk, type is represented by class, which is also the template for instance creation)
	- HelloWorld template

	test that we can configure a service with HelloWorld instance and run it correctly.

test that a service can create a new service with a distinct service context, i.e., the new service context will use a different service planner.

test that capsule can access multiple local persistent repositories:
- cache of global repository immutable objects is locally persistent
	at startup, repository discovers which persistent repositories are locally accessible and instantiates these (lazily?)
	cache is local persistent store.
	local persistent repositories are simple directories of binary files with name of logical repository and root directory identified in configuration file
- discovery protocol for repositories executed at capsule initialization:
	capsule init takes configuration properties that specify cache location and repository implementation
	repository implementation is loaded from cache with capsule mechanisms, repository instantiation includes initialization
	repository initialization looks in capsule configuration properties for local repository definition list
	repository implementation determines when these local repositories are instantiated and verified as well as how resolution of names to repositories is implemented.
	!

!QuAStep1 methodsFor: 'Testing' stamp: 'ras 9/29/2004 15:35'!
testThreeComponentService
	capsule
		publishFrom: Gen
		name: (QuA name: '/demo/GenFactory-blueprint')
		forFactoryType: (QuA name: '/demo/GenFactory')
		instanceType: (QuA name: '/demo/Gen')
		requires: Props none.
	capsule
		publishFrom: Sum
		name: (QuA name: '/demo/SumFactory-blueprint')
		forFactoryType: (QuA name: '/demo/SumFactory')
		instanceType: (QuA name: '/demo/Sum')
		requires: Props none.

	QuA compose: (
		QuA newCompositionSpec
			addInstanceOf: (QuA name: '/demo/Gen') role: 'gen';
			addInstanceOf: (QuA name: '/demo/Sum') role: 'sum';
			addObject: (capsule quaNameFor: self) role: 'self';
			set: 'gen' property: 'output' to: 'sum';
			set: 'self' property: 'obj' to: 'gen';
			set: 'self' property: 'obj2' to: 'sum'
		).
	
		obj gen1To: 3.	
	
		self assert: ( obj2 sum = 6 ).
	! !

!QuAStep1 methodsFor: 'Testing' stamp: 'ras 3/4/2003 18:16'!
value: anObject
	result _ anObject
! !

!QuAStep1 methodsFor: 'Testing' stamp: 'ras 3/5/2003 22:18'!
obj: anObject
	obj _ anObject
! !

!QuAStep1 methodsFor: 'Testing' stamp: 'ras 3/5/2003 22:20'!
obj2: anObject
	obj2 _ anObject
! !

!QuAStep1 methodsFor: 'Testing' stamp: 'ras 5/7/2004 15:33'!
tearDown
	capsule shutdown! !

!QuAStep1 methodsFor: 'Testing' stamp: 'ras 5/18/2004 01:04'!
testVersion

	self assert: Smalltalk version = 'Squeak3.7beta'.
	"self assert: Smalltalk lastUpdateString = 'latest update: #5156'."
	"self assert: Smalltalk changes name = 'QuA proto'."
	"self assert: Smalltalk changes isEmpty."	"empty only with fresh image"
! !

!QuAStep1 methodsFor: 'Testing' stamp: 'ras 3/18/2004 13:57'!
setUp
	QuA initialize.
	capsule _ QuA thisCapsule.
	capsule	servePersistentRepository: (QuA name: '/demo').
! !

!QuAStep1 methodsFor: 'Testing' stamp: 'ras 9/29/2004 15:29'!
testPublish
	capsule
		publishFrom: HelloWorld
		name: (QuA name: '/demo/HelloWorldFactory-blueprint')
		forFactoryType: (QuA name: '/demo/HelloWorldFactory')
		instanceType: (QuA name: '/demo/HelloWorld')
		requires: Props none.
	QuA compose: (
		QuA newCompositionSpec 
			addInstanceOf: (QuA name: '/demo/HelloWorld') role: 'hw';
			addObject: (capsule quaNameFor: self) role: 'self';
			set: 'hw' property: 'output' to: 'self';
			set: 'self' property: 'obj' to: 'hw'
	).
	obj run.
	self assert: result = 'Hello World'! !

TestCase subclass: #QuAChessDemo
	instanceVariableNames: 'capsule result game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!QuAChessDemo methodsFor: 'Testing' stamp: 'ras 3/17/2004 10:26'!
tearDown
	capsule shutdown! !

!QuAChessDemo methodsFor: 'Testing' stamp: 'ras 10/6/2004 11:54'!
setUp
	QuA initialize.
	capsule _ QuA thisCapsule.
	capsule	servePersistentRepository: (QuA name: '/chess').
	capsule
		publishFrom: Chess
		name: (QuA name: '/chess/GameFactory-blueprint')
		forFactoryType: (QuA name: '/chess/GameFactory')
		instanceType: (QuA name: '/chess/Game')
		requires: (Props fromTypes: { 
			'board'->(QuA name: '/chess/Board'). 
			'player1'->(QuA name: '/chess/Robot'). 
			'player2'->(QuA name: '/chess/Robot').  }).
	capsule
		publishFrom: Robot
		name: (QuA name: '/chess/RobotFactory-blueprint')
		forFactoryType: (QuA name: '/chess/RobotFactory')
		instanceType: (QuA name: '/chess/Robot')
		requires: Props none.
	capsule
		publishFrom: Board
		name: (QuA name: '/chess/BoardFactory-blueprint')
		forFactoryType: (QuA name: '/chess/BoardFactory')
		instanceType: (QuA name: '/chess/Board')
		requires: Props none.
! !

!QuAChessDemo methodsFor: 'Testing' stamp: 'ras 3/17/2004 10:29'!
testPlay
	game _ QuA instanceOf: (QuA name: '/chess/Game').
	result _ game play.
	self assert: ((result = 'white') or: [ (result = 'black') or: [ result = 'draw'. ]. ]).! !

TestCase subclass: #QuAQRMIProtocolTest
	instanceVariableNames: 'source sink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!QuAQRMIProtocolTest methodsFor: 'as yet unclassified' stamp: 'ras 6/18/2004 16:24'!
sink: obj
	sink _ obj! !

!QuAQRMIProtocolTest methodsFor: 'as yet unclassified' stamp: 'ras 10/7/2004 13:38'!
persistentSetup
	"QuAQRMITest new persistentSetup"
	QuASetup initializeTemp.
	QuASetup cacheBlueprints: {
		'QRMITestProxy'->'QRMITestProxy'.
		'QRMIProtocol'->'QRMIProtocol'.
		'TestDataType'->'TestDataType'.
		'TestSource'->'TestSource'.
		'TestSink'->'TestSink'.
	}.
	QuASetup advertiseCapabilityPlans: {
		{ QuA name: '/c1'. Props fromValues: { 'host'->'localhost'. 'port'->8301. }. }.
		{ QuA name: '/c2'. Props fromValues: { 'host'->'localhost'. 'port'->8000. }. }.
	}.
! !

!QuAQRMIProtocolTest methodsFor: 'as yet unclassified' stamp: 'ras 6/18/2004 16:24'!
source: obj
	source _ obj! !

!QuAQRMIProtocolTest methodsFor: 'as yet unclassified' stamp: 'ras 9/15/2004 17:32'!
setUp
	self persistentSetup.
	QuASetup initializeWithRepository: (QuA name: '/c1').
	QuA thisCapsule serveVolatileRepository: (QuA name: '/c2').


! !

!QuAQRMIProtocolTest methodsFor: 'as yet unclassified' stamp: 'ras 9/16/2004 13:36'!
testProtocol
	QuA thisServiceContext 
		compositionPlanner: (QRMITestPlanner new 
			remoteRepository: (QuA resolve: (QuA name: '/c2'));
			yourself
		).
	QuA compose: ((QuA newCompositionSpec)
			addInstanceOf: (QuA name: '/demo/TestSource') role: 'source';
			addInstanceOf: (QuA name: '/demo/TestSink') role: 'sink';
			addObject: (QuA thisCapsule quaNameFor: self) role: 'self';
			set: 'source' property: 'output' to: 'sink';
			set: 'self' property: 'source' to: 'source';
			set: 'self' property: 'sink' to: 'sink'
	) withQuality: nil.

	source run: 'test data'.

	self assert: sink result = 'test data'.
! !

!QuAQRMIProtocolTest methodsFor: 'as yet unclassified' stamp: 'ras 8/25/2004 17:30'!
tearDown
	QuA thisCapsule shutdown! !

TestCase subclass: #QuANameTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!QuANameTests methodsFor: 'as yet unclassified' stamp: 'ras 5/26/2003 21:52'!
testParse
	| name |
	name _ QuA name: '/a/b/c:1.0'.
	self assert: ( name repositoryNameString = '/a/b' ).
	self assert: ( name shortName = 'c' ).
	self assert: ( name version = 1 ).
	self assert: ( name fixLevel = 0 ).! !

!QuANameTests methodsFor: 'as yet unclassified' stamp: 'ras 5/26/2003 21:52'!
testParseCanonical
	| name |
	name _ QuA name: '/a/b/c:1.0'.
	name _ QuA name: name printString.
	self assert: ( name repositoryNameString = '/a/b' ).
	self assert: ( name shortName = 'c' ).
	self assert: ( name version = 1 ).
	self assert: ( name fixLevel = 0 ).! !

TestCase subclass: #QuAImplBrokerTest
	instanceVariableNames: 'capsule result obj obj2 reflection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!QuAImplBrokerTest commentStamp: 'ras 1/28/2004 10:21' prior: 0!
In setup, we advertise two blueprints; one for a factory and one for an instance:
	plan: blueprint for XFactory, blueprint name XFactoryBlueprint, requires SqueakCapsule
		means get an instance of SqueakCapsule and tell it to instantiate an XFactory from blueprint XFactoryBlueprint
	plan: blueprint for X, blueprint name XBlueprint, requires SqueakCapsule
		means get an instance of SqueakCapsule and tell it to instantiate an X from blueprint XBlueprint

Now the type XFactory can also be advertised as a way to create instances of X:
	plan: manufacture X, requires XFactory
		means tell XFactoryInstance to manufacture an X

An instance may be advertised as a plan to satisfy a type:
	plan: instance of X, name XInstance
		means can use XInstance as instance of X
	plan: instance of XFactory, name XFactoryInstance
		means can use XFactoryInstance as instance of XFactory

So, if we begin service planning with the above plans in our implementationBroker and the following goal:

	goal: instance of X

we should get the following plan alternatives:

1	plan: instance of X, name XInstance
2	plan: manufacture X, requires XFactory	
3	plan: blueprint for X, blueprint name XBlueprint, requires SqueakCapsule

Plan 1 is easiest to execute, just use XInstance.
Plan 2 requires an instance of XFactory, so service planning must be invoked again with the goal:

	goal: instance of XFactory

which should get the following results:

4	plan: instance of XFactory, name XFactoryInstance
5	plan: blueprint for XFactory, blueprint name XFactoryBlueprint, requires SqueakCapsule

Again, plan 4 is trivial, but plan 5 requires an instance of SqueakCapsule:

	goal: instance of SqueakCapsule

This goal could be satisfied by the local capsule, but if not, the ImplementationBroker would have to return plans to use remote instances that had been advertised or possibly some plan to manufacture instances.
Plan 5 then represents as many plans as there are bindings for the SqueakCapsule requirement.
Similarly, plan 3 represents as many plans as there are bindings for the SqueakCapsule requirement.

If plans 1, 3 and 4 did not exist (or were not selected for any other reason), the result of service planning would be a plan that selected a SqueakCapsule, told it to instantiate an XFactory from XBlueprint, then told this XFactory to manufacture an X.
A side effect of instantiating the XFactory might be that the capsule chooses to advertise this as seen in plan 4.
A repeat request for an instance of X might then be satisfied by executing plan 4 to get the factory and then executing plan 2 for the instance.
!

!QuAImplBrokerTest methodsFor: 'Testing' stamp: 'ras 5/7/2004 15:32'!
tearDown
	capsule shutdown! !

!QuAImplBrokerTest methodsFor: 'Testing' stamp: 'ras 9/29/2004 15:34'!
setUp
"
In setup, we advertise two blueprints; one for a factory and one for an instance:
	plan: blueprint for XFactory, blueprint name XFactoryBlueprint, requires SqueakCapsule
		means get an instance of SqueakCapsule and tell it to instantiate an XFactory from blueprint XFactoryBlueprint
	plan: blueprint for X, blueprint name XBlueprint, requires SqueakCapsule
		means get an instance of SqueakCapsule and tell it to instantiate an X from blueprint XBlueprint

Now the type XFactory can also be advertised as a way to create instances of X:
	plan: manufacture X, requires XFactory
		means tell XFactoryInstance to manufacture an X

An instance may be advertised as a plan to satisfy a type:
	plan: instance of X, name XInstance
		means can use XInstance as instance of X
	plan: instance of XFactory, name XFactoryInstance
		means can use XFactoryInstance as instance of XFactory
"
	QuA initialize.
	capsule _ QuA thisCapsule.
	capsule servePersistentRepository: (QuA name: '/demo').
	capsule 
		publishFrom: TestComponentFactory
		name: (QuA name: '/demo/TestComponentFactory-blueprint') 
		forFactoryType: (QuA name: '/demo/TestComponentFactory')
		instanceType: (QuA name: '/demo/TestComponent') 
		requires: Props none.
! !

!QuAImplBrokerTest methodsFor: 'Testing' stamp: 'ras 3/19/2004 17:35'!
testGetInstanceByFactory
	| broker |
		broker _ QuA thisServiceContext implementationBroker.
		"make sure there are no instances, so that one must be manufactured by factory"
		broker removeAll: ((broker plansFor: (QuA name: '/demo/TestComponent')) select: [ :plan | plan isKindOf: InstancePlan. ]).
		obj _ QuA instanceOf: (QuA name: '/demo/TestComponent').
		self assert: (obj hello = 'Hello World').
! !

!QuAImplBrokerTest methodsFor: 'Testing' stamp: 'ras 3/19/2004 17:34'!
testGetFactory
		obj _ QuA instanceOf: (QuA name: '/demo/TestComponentFactory').
		self assert: (obj new hello = 'Hello World').
! !

CompositionPlanner subclass: #QRMITestPlanner
	instanceVariableNames: 'remoteRepository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!QRMITestPlanner methodsFor: 'as yet unclassified' stamp: 'ras 10/5/2004 17:22'!
compose: aCompositionBlueprint withQuality: extraFunctionalSpec in: context
	"instantiate all new components, create bindings and set properties"
	| objects |

	objects _ aCompositionBlueprint components copy.
	aCompositionBlueprint newComponents keysAndValuesDo: [ :role :type |
		(role = 'sink') 
			ifTrue: [ objects at: role put: (QuA 
				instantiate: type 
				properties: (Props fromQuANames: {'platform'->(QuA nameFor: remoteRepository capsule).})
				withQuality: nil).
			] 
			ifFalse: [ objects at: role put: (QuA instantiate: type). ].
	].

	aCompositionBlueprint bindings do: [ :binding |
		QuA
			bind: (objects at: binding sender) 
			property: binding propertySelector
			to: (objects at: binding receiver)
			withQuality: nil.
	].
! !

!QRMITestPlanner methodsFor: 'as yet unclassified' stamp: 'ras 6/21/2004 20:59'!
remoteRepository: obj
	remoteRepository _ obj! !

ErrorEstimator subclass: #TH263Estimator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!TH263Estimator methodsFor: 'as yet unclassified' stamp: 'ras 10/7/2004 11:15'!
errorFor: configuration
	^(Dictionary new)
		at: 'delay' put: 350;
		at: 'period' put: 72;
		at: 'noise' put: 0.045;
		yourself.
! !

ErrorEstimator subclass: #TMPEGEstimator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QuATests-Prototype'!

!TMPEGEstimator methodsFor: 'as yet unclassified' stamp: 'ras 10/7/2004 11:14'!
errorFor: configuration
	^(Dictionary new)
		at: 'delay' put: 351;
		at: 'period' put: 330;
		at: 'noise' put: 0;
		yourself.
! !
